import math

def int2def(wav:int) -> str:
    '''
    convert integer to WAV definition string.
    #from 1-1295 to "01"-"ZZ".
    '''

    zz = [str(i) for i in range(10)]+[chr(i) for i in range(65,91)]
    a = math.floor(wav/36)
    b = int(wav%36)
    return zz[a]+zz[b]

def def2int(deff:str) -> int:
    '''
    convert WAV definition string to integer.
    #from "01"-"ZZ" to 1-1295.
    '''

    zz = [str(i) for i in range(10)]+[chr(i) for i in range(65,91)]
    a = zz.index(deff[0])
    b = zz.index(deff[1])
    return a*36+b
