import bmslib
from bmslib.random import *
import random
import sys

# const
sound_type = ["shot", "long", "impact", "piano-hi", "piano-lo", "bass"]
sound_range = {"shot": ("01","0H"), "long": ("11","17"), "impact":("21","25"), 
                "piano-hi":("41","4K"), "piano-lo":("51","55"), "bass":("31","31")}
sound_range_rdd = {"shot": ("A1","AH"), "long": ("B1","B7"), "impact":("C1","C5"), "piano-hi":("D1","DK"), "bass":("E1","E1")}
obj_res = [1,2,3,4,6,8,12,16,24,32,48,64,96,128,192]
obj_res_short = [4,6,8,12,16]
obj_res_impact = [1,2,4,8]
obj_res_long = [1,4]
obj_res_retrigger = [24,64,96,128,192]#32,48,



# parameter
resolution = 192 # resolution with 4/4
song_length = 48
bar_length = 0.75 # 0.75, 1, 1.25
bms_path = "pp.bms"
header_path = "header.txt"
bpm = [99,100,101,80,90,96]
seed = 0 if len(sys.argv) != 2 else int(sys.argv[1])


# init
random.seed(seed)

bms = bmslib.BMSfile(header_path, bms_path)
p = bmslib.Pattern(resolution, song_length, bar_length)

#bpm randomize (optional)
#for i in range(1,song_length):
#    p.ext_command("03:{:X}".format(randlist(bpm)),i)


#generate
for bar in range(1, song_length+1): # +1 = last bar
    for sound in sound_type:
        wav = randef(sound_range[sound])

        #note(short)
        if sound in ["shot","bass"]:
            for q_cnt in range(p.num_quarter):
                res = randlist(obj_res_short)
                wav = randef(sound_range[sound])

                niq = p.num_in_quarter(res)
                for c in range(niq):
                    cnt = niq*q_cnt + c
                    if coin():
                        #sep bass / shot
                        if sound in ["shot"]:
                            while True:
                                lane = random.randint(1,7) #random.randint(0,7)
                                if p.note(lane, bar, cnt, res, wav):
                                    break
                        else:#"bass"
                            p.bgm(bar, cnt, res, wav)
        
        #note(fx)
        if sound in ["impact"]:
            res = randlist(obj_res_impact)
            for cnt in range(p.num_in_bar(res)):
                if coin(0.6):
                    while True:
                        lane = 0 # random.randint(0,7)
                        if p.note(lane, bar, cnt, res, wav):
                            break
        
        #bgm(long)
        if sound in ["long"]:
            res = randlist(obj_res_long)
            cnt = randint(p.num_in_bar(res))
            p.bgm(bar, cnt, res, wav)
        
        # piano(Hi)
        if sound in ["piano-hi"]:
            res = randlist([1,2,4])
            for q_cnt in range(p.num_quarter):
                niq = p.num_in_quarter(res)
                wav = randef(sound_range[sound])
                for c in range(niq):
                    cnt = niq*q_cnt + c
                    if coin(1):
                        while True:
                            lane = random.randint(4,7)
                            if p.note(lane, bar, cnt, res, wav):
                                break

        # piano(Lo)
        if sound in ["piano-lo"]:
            res = 1
            cnt = 0
            if coin(0.4):
                while True:
                    lane = random.randint(1,3)
                    if p.note(lane, bar, cnt, res, wav):
                        break



    #bgm(retrigger)   
    q_cnt = randint(p.num_quarter)
    res = randlist(obj_res_retrigger)
    wav = randef(sound_range_rdd[randlist(["shot","piano-hi"])])#"impact",

    niq = p.num_in_quarter(res)
    if res in [24]:
        lane = random.randint(1,7)
    for c in range(niq):
        cnt = q_cnt*niq + c
        if c >= niq/2:
            lane = (lane+1) % 8
        if res in [24]:
            p.note(lane, bar, cnt, res, wav, force=True)
        else:
            p.bgm(bar, cnt, res, wav)



# export
bms.write_BMSfile(p.export(), "* This BMS is generated with seed: {}".format(seed))